%define flavor emacs

Summary: A high-level language for numerical computations
Name:	 scilab
Version: 4.1.2
Release: %mkrel 4
License: SCILAB
Group: Sciences/Mathematics
Source0: http://www.scilab.org/download/%{version}/%{name}-%{version}-src.tar.gz
Source20: scilab.el
Patch1:	0001-UseStandardXaw.patch
Patch2: 0002-file-menu.patch
# Fixes: scilab broken : missing symlink and error message
# https://qa.mandriva.com/show_bug.cgi?id=40116
Patch3: 0003-scipad.diff
URL: http://www.scilab.org/
BuildRequires: perl vte-devel
BuildRequires: tcl-devel >= 8.5
BuildRequires: tk-devel >= 8.5
BuildRequires: xaw-devel
BuildRequires: emacs-nox libgcj-devel gcc-gfortran
BuildRequires: gcc-java ocaml
BuildRequires: ImageMagick sablotron
BuildRequires: libpvm-devel
Requires: tcl >= 8.5
Requires: tk >= 8.5
Requires: pvm ocaml gcc-gfortran
BuildRoot: %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: %ix86

%description
Scilab is a high-level language, primarily intended for numerical
computations.  Scilab includes a number of toolboxes and on-line
documentation.

%prep
rm -rf %{buildroot}
%setup -q 

%patch1 -p1 -b .xaw
%patch2 -p1 -b .filemenu
%patch3 -p1 -b .scipad

%build
%configure2_5x	\
	--enable-shared \
	--with-gfortran \
	--with-java \
	--with-ocaml \
	--enable-static=no

# fix java include path
perl -pi -e "s/JAVAINC=.*/JAVAINC=/" routines/Javasci/Makefile

make all

cp -af %SOURCE20 .
for i in %{flavor};do
	$i -batch -q -no-site-file -f batch-byte-compile %{name}.el
	mv %{name}.elc $i-%{name}.elc
done

%install
rm -rf %{buildroot}
install -d -m0755 %{buildroot}%{_bindir}
install -d -m0755 %{buildroot}%{_libdir}
perl -pi.orig -e '
		s|/usr/bin|%{buildroot}%{_bindir}|g;
		s|/usr/lib|%{buildroot}%{_libdir}|g;
		s|ln -fs \$\(PREFIX\)/lib|ln -fs %{_libdir}|g;
	' Makefile

perl -pi -e 's|/bin/sh5|/bin/sh|g;' bin/dold
make install PREFIX="%{buildroot}%{_prefix}" LIBPREFIX="%{buildroot}%{_libdir}"

# Duplicated documentation
rm -fr %{buildroot}/%{_defaultdocdir}/%{name}-%{version}

perl -pi -e ' s|%{buildroot}||g;' %{buildroot}%{_libdir}/scilab-%{version}/bin/*

# Icons
install -d %{buildroot}/%{_miconsdir}
install -d %{buildroot}/%{_liconsdir}
convert X11_defaults/%{name}.xpm -geometry 48x48 %{buildroot}%{_liconsdir}/%{name}.png
convert X11_defaults/%{name}.xpm -geometry 32x32 %{buildroot}%{_iconsdir}/%{name}.png
convert X11_defaults/%{name}.xpm -geometry 16x16 %{buildroot}%{_miconsdir}/%{name}.png

# Menu

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mandriva-%{name}.desktop << EOF
[Desktop Entry]
Name=Scilab
Comment=High-level language for numerical computations
Exec=scilab
Icon=scilab
Terminal=false
Type=Application
Categories=X-MandrivaLinux-MoreApplications-Sciences-Mathematics;
EOF


# (X)emacs
for i in %{flavor};do
	mkdir -p %{buildroot}%{_datadir}/$i/site-lisp/
	mkdir -p %{buildroot}%{_datadir}/emacs/site-lisp/
	install -m644 $i-%{name}.elc %{buildroot}%{_datadir}/$i/site-lisp/
	[[ $i = emacs ]] && install -m644 %{name}.el %{buildroot}%{_datadir}/emacs/site-lisp/
done

mkdir -p %{buildroot}/%{_sysconfdir}/emacs/site-start.d
install -m644 %{SOURCE20} %{buildroot}/%{_sysconfdir}/emacs/site-start.d/%{name}.el

# Links libtk8.5.so.0 to scilab's bindir to avoid runtime warnings about
# devel files not installed
ln -sf %{_libdir}/libtk8.5.so.0 %{buildroot}/%{_libdir}/%{name}-%{version}/bin/libtk8.5.so

%post
%{update_menus}

%postun
%{clean_menus}


%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc ACKNOWLEDGEMENTS CHANGES license.txt licence.txt
%_bindir/*
%_libdir/scilab-*
%{_miconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%config(noreplace) /etc/emacs/site-start.d/%{name}.el
%{_datadir}/*/site-lisp/*el*
%_datadir/applications/*


%changelog
* Tue Apr 22 2008 Paulo Andrade <pcpa@mandriva.com.br> 4.1.2-4mdv2008.1
+ Revision: 196650
- Correct a problem where scilab's scipad would not work correctly
  if a configuration file did not already exist in the user's home
  directory, and a problem where scipad would try to link with files
  from devel packages, printing unnecessary warning messages.

* Thu Jan 31 2008 Paulo Andrade <pcpa@mandriva.com.br> 4.1.2-2mdv2008.1
+ Revision: 160802
- Update to compile in cooker and change to use gfortran instead of g77.

  + Thierry Vignaud <tvignaud@mandriva.com>
    - drop old menu
    - kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Fri Oct 26 2007 Paulo Andrade <pcpa@mandriva.com.br> 4.1.2-1mdv2008.1
+ Revision: 102397
- Oops, messed in previous commit and added requires to atlas, that should have been removed.
- Update to version 4.1.2, fix Tk 8.5 dependency and add ocaml dependency.
  Minor cosmetic changes to Xaw file dialog.

* Fri Sep 28 2007 Olivier Blin <oblin@mandriva.com> 4.1.1-1mdv2008.0
+ Revision: 93801
- build on ix86 only (x86_64 build fails because configure does not
  look for tcl and tk libraries in lib64, and use g77 with invalid
  -march=athlon64 option)

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Requires tcl >= 8.5. Hopefully this should fix the build problems.
    - After some "fighting" with java/ocaml support to try to add support for either
      gtk or gtk2 I give up and just add BuildRequires to xaw-devel, due to all kinds
      of errors of either duplicated or missing symbols.
    - import scilab


